XRayVision = AceLibrary("AceAddon-2.0"):new("AceDB-2.0", "AceConsole-2.0", "AceHook-2.1")
XRayVision:RegisterDB("XRayVisionDB")
local _G = getfenv(0)
local L = AceLibrary("AceLocale-2.2"):new("XRayVision")
L:RegisterTranslations("enUS", function() return {
	["Shows bag contents in the tooltip"] = true
} end)

function XRayVision:OnInitialize()
	XRayVision:RegisterChatCommand({"/xrayvision", "/xray"}, {
		desc = L["Shows bag contents in the tooltip"],
		type = "group",
		args = {},
	})
end

function XRayVision:OnEnable()
	self:SecureHook("BagSlotButton_OnEnter")
	for i = 1, 6 do
		self:HookScript(_G["BankFrameBag"..i], "OnEnter")
	end
	self:HookScript(MainMenuBarBackpackButton, "OnEnter")
end

function XRayVision:BagSlotButton_OnEnter(backpack)
	if not backpack then self.hooks.BagSlotButton_OnEnter() end
	if not GameTooltip:IsVisible() then return end
	local bag = backpack and this:GetID() or (this:GetID() - 19)
	local items = {}
	for i = 1, GetContainerNumSlots(bag) do
		local link = GetContainerItemLink(bag, i)
		if link then
			table.insert(items, link)
		end
	end
	table.sort(items, function(a,b)
		--local a1 = string.gsub(a, "%[(.-)%]", "%1")
		--local b1 = string.gsub(b, "%[(.-)%]", "%1")
		return a < b
	end)
	for _, v in items do
		GameTooltip:AddLine(v)
	end
	GameTooltip:Show()
end

function XRayVision:OnEnter()
	-- Call the original function before adding stuff to the tooltip.
	self.hooks[this]["OnEnter"]()
	self:BagSlotButton_OnEnter(1)
end
